#ifndef CursesScreen_INCLUDED
#define CursesScreen_INCLUDED

#include "Egyke.h"
#include "Observable.h"

typedef struct {
	int x;
	int y;
} Point;

//A boilerplate kod egy kis elrejtese.
@interface CursesScreen: Egyke {
	boolean isRunning; // A belso megjelenitesi ciklus futasat jelzi, amit ennek atkapcsolasaval illetve a stop fv-el lehet leallitani
	Observable* draw;  // backingfield
}
	@property (readonly) Observable* draw;
	//Ezen az "esemenyen" keresztul adja at a vezerlest az esetleg rajzolni akaroknak

	-(id) init;
	-(void) dealloc;
	
	-(void) start;								// vegtelen ciklust indit, ami a draw esemenyt hivja
	-(void) stop;								// tipikusan draw-bol hivodik
	
	-(int) getScreenWidth; 						// oszlopok szama
	-(int) getScreenHeight;						// sorok szama
	
	-(void) clearScreen;
	
	-(void) putChar: (char) ch at: (Point) pos;
	-(void) putStr: (NSString*) str at: (Point) pos;
	
	-(char) getChar;
@end
#endif