#include <curses.h>
#include "CursesScreen.h"

@implementation CursesScreen
	@synthesize draw;
	
	-(id) init{
		isRunning = false;
		draw = [Observable new];
		initscr(); 								// inicializalja a default kepernyot(stdscr)
		
		nl(); 									// a bevitelnel az enter newline lesz
		noecho(); 								// ne irja ki a beutott karaktereket
		curs_set(0); 							// lathatatlanna teszi a kurzort
		timeout(0); 							// nem blokkolo bemenetre kapcsolja az ablakot
		keypad(stdscr, TRUE); 					// bekapcsolja a numpadot
		
		return self;
	}
	
	-(void) dealloc{
		[draw release];
		[super dealloc];
	}
	
	-(void) start{
		isRunning = true;

		while(isRunning){
			[draw notify]; 						// a vezerles atadasa az esetleges rajzoloknak-vezerloknek.
			napms(50);  
		}
		
		erase();
		curs_set(1); 							//visszaallitjuk a konzolt..
		endwin();
	}
	
	-(void) stop{
		isRunning = false;
	}
	
	-(int) getScreenWidth{
		int x,y;
		getmaxyx(stdscr,y,x);					
		return x;
	}
	
	-(int) getScreenHeight{
		int x,y;
		getmaxyx(stdscr,y,x);
		return y;
	}
	
	-(void) clearScreen{
		clear();
	}
	
	-(void) putChar: (char) ch at: (Point) pos{
		mvaddch(pos.y, pos.x, ch);					// y, x, char kirajzolas
	}
	-(void) putStr: (NSString*) str at: (Point) pos{
		mvaddstr(pos.y, pos.x, [str UTF8String]); 	// y,x, string kirajzolas
	}
	
	-(char) getChar{
		return getch();								//beolvasas, pdcursesbol.
	}
@end