#include "Game.h"

@implementation Game
	-(id) init: (CursesScreen*) scr{
		groundIndex = 0;
		running = false;
		gameOver = false;
		
		
		screen = scr;
		
		maxY = [screen getScreenHeight];			// lekerjuk a konzol mereteit
		maxX = [screen getScreenWidth]; 
		
		buggy = [[Buggy alloc] init: scr withBasePosition: (Point){.x = 10, .y = maxY - 5}];
		
		[self initGroundText];
		
		srand(time(NULL));
		return self;
	}
	
	-(void) initGroundText{ 						//A jatek elkezdesekor a palya generalasa
		groundIndex = 0;
		int i;
		for(i=0;i<maxX;++i){
			if(i<maxX*3/4) groundText[i] = '#'; 	// a palya elejen ne legyen lyuk, nem jo ha egybol beleesik a jatekos
			else [self generateGroundText: i]; 		// a maradekot normalisan generaljuk
		}
	}
	
	-(void) generateGroundText: (int) i{ 			//Az i. elem (ujra)generalasa
		if(i<4) i+=maxX;							// a korbefordulas miatt, bar elvileg ilyen nem fordulhat elo
		
		int prevHole = 0; 							// itt szamoljuk meg, hogy az elozo par helyen hany lyuk volt
		int j;
		for(j=1;j<buggy.width+2;++j){
			if(groundText[(i-j)%maxX] == '_') prevHole ++;
		}
		
		if((groundText[(i-1)%maxX] != '_' && prevHole > 0) ||//ezzel biztositjuk, hogy barmely ket lyuk koze befer a kocsi
		   (groundText[(i-1)%maxX] == '_' && prevHole > 6) 	 //ezzel pedig hogy at is tudjon ugorni az ilyen lyukakon
			) 
				groundText[i%maxX] = '#'; 
		else if(rand()% 1000 < i) 							//< sqrt(i*10)*(3-prevHole)) egy korabbi generalo probalkozas
			groundText[i%maxX] = '_'; 						//veletlenszeruen eldontjuk, hogy van-e lyuk.
		else groundText[i%maxX] = '#'; 
		
	}
	
	-(void) handleInput: (char) c{
		switch (c)//bemenet kezeles
		{
			case 'P':
			case 'p':
				[screen putStr: @"Leallitva" at: (Point){.x = maxX/2-5, .y = maxY/2+1}];
				paused = !paused;
				break;
			case 'q':
			case 'Q':
				[screen stop];
			case ' ':
				[buggy jump];
				break;
			case 'R':
			case 'r':
				[self initGroundText];
				groundIndex = 0;
				gameOver = false;
				running = true;
				break;
		}
	}
	
	-(void) draw{
		[self handleInput: [screen getChar]];
		if(paused) {
			return;
		}
		[screen clearScreen];
		[screen putStr: @"Uj jatek inditasahoz nyomja meg az r-gombot." at: (Point){.x = 2, .y = 2}];
		[screen putStr: @"Kilepeshez nyomja meg a q-gombot." at: (Point){.x = 2, .y = 3}];
		[screen putStr: @"Ugras a szokoz gombbal." at: (Point){.x = 2, .y = 4}];
			// egyszeru kiirasok
		
		if([buggy onGround]) {
			 
			bool hole = false;
			int i = 1;
			while(i<buggy.width-1&&!hole){
				if(groundText[(groundIndex + i + 10) % maxX] == '_') hole = true;
				++i;
			}
			if(hole){
				running = false;
				gameOver = true;
			}
		}
		[buggy draw];	//a holdjaro kirajzolasa
		
		if(gameOver){
			[screen putStr: @"Game Over!" at: (Point){.x = maxX/2-5, .y = maxY/2-1}];
			[screen putStr: [NSString stringWithFormat: @"Pontszam: %d ", groundIndex] 
						at: (Point){.x = maxX/2-7, .y = maxY/2}];
		}
		
		int i;
		for(i=1;i<maxX;++i){ // a fold kirajzolasa
			[screen putChar: groundText[(i+groundIndex)%maxX] at: (Point){.x = i-1, .y = maxY-4}];
		}
		char ch;
		for(i=1;i<maxX-1;++i){ // a fold kirajzolasa: 2. sor
			ch = '#';
			if(groundText[(i+groundIndex)%maxX] == ' ' &&
				groundText[(i+1+groundIndex)%maxX] == ' ' &&
				groundText[(i-1+groundIndex)%maxX] == ' ')
			[screen putChar: ch at: (Point){.x = i - 1, .y = maxY-3}];
		}
		
		for(i=0;i<maxX;++i){ // a fold kirajzolasa
			ch = '#';
			[screen putChar: '#' at: (Point){.x = i, .y = maxY-3}];
		}
		if(running) { // leptetes es a kovetkezo foldkocka generalasa
			[self generateGroundText: groundIndex];
			groundIndex++;
		}
		
		[self handleInput: [screen getChar]];
	}
@end