#include "observable.h"

@implementation Observable
	-(id) init{
		observers = [[NSMutableArray alloc] init];
		return self;
	}
	
	-(void) dealloc{
		[observers release];
		[super dealloc];
	}
	
	-(void) attach: (id) object withSelector: (SEL) sel{
		NSInvocation* handler = [NSInvocation invocationWithMethodSignature: 
								[[object class] instanceMethodSignatureForSelector: sel]];
		[handler setTarget: object];
		[handler setSelector: sel];
		[observers addObject: handler];
	}
	
	-(void) detach: (id) object withSelector: (SEL) sel{
		NSMutableArray* discard = [NSMutableArray array];
		for(NSInvocation* invocation in observers){
			if( [invocation.target isEqual: object] && sel_isEqual(invocation.selector, sel)){
				[discard addObject: invocation];
			}
		}
		[observers removeObjectsInArray: discard];
	}
	
	-(void) notify{
		for(NSInvocation* invocation in observers)
		{
			[invocation invoke];
		}
	}
@end